
import com.sun.jna.Library;
import com.sun.jna.Native;
import com.sun.jna.WString;
 
interface Repcoder_lib extends Library
  {
   Repcoder_lib INSTANCE = (Repcoder_lib)Native.loadLibrary((System.getProperty("sun.arch.data.model").equals("64"))? "repcoder64": "repcoder", Repcoder_lib.class);
					
   int repc_init();
   void repc_exit();

   int repc_open_report(int hParent, int bModal, WString FormName, int RecordSeqNr,
   int nParams, int[] pParamsNumbers, WString[] pParamsValues, int bParamsUpdate,
   int bRecNavigate, int bDesignMode, int bAllowDesign, int bAllowUpdate);

   int repc_open_report2(int hParent, int bModal, WString FormName, int RecordSeqNr,
   WString Parameters, int bParamsUpdate,
   int bRecNavigate, int bDesignMode, int bAllowDesign, int bAllowUpdate);
   
   int repc_call_report(int hParent, int bModal, WString FormName, int bDesignMode);

   int repc_call_report_param(int hParent, int bModal, WString FormName, int bDesignMode, 
   int nParams, int[] pParamsNumbers, WString[] pParamsValues, int bParamsUpdate);

   int repc_call_report_param2(int hParent, int bModal, WString FormName, int bDesignMode, 
   WString Parameters, int bParamsUpdate);
   
   void repc_explorer(int hParent, int bModal, WString Dir, int bDesign, int bResultOnly);
   
   void repc_explorer_param(int hParent, int bModal, WString Dir, int bDesign, int bResultOnly,
   int nParams, int[] pParamsNumbers, WString[] pParamsValues, int bParamsUpdate);
   
   int repc_get_report_desc_len(WString FormName);
   int repc_get_report_desc(WString FormName, char[] buf, int len);
   
   int repc_get_open_count();
   int repc_can_exit();
   
   void repc_set_user(WString User);
   void repc_set_pass(WString Pass);   
   void repc_set_role(WString Role);   
   void repc_set_charset(WString Charset);
   
   void repc_set_logo(WString szLogo, int bReplace);
   
   int repc_get_demo();
   int repc_set_demo(int bDemo);
   
   void repc_set_bde_netdir(WString dir);
   
   void repc_set_fbclient_thread_safe(int bSafe);
   void repc_set_ibclient_thread_safe(int bSafe);
   
   void repc_set_dialog_fonts(int Type);
   void repc_set_user_interface_lang(int Lang);

   int repc_create_result(WString FormName, WString ResultName, WString ResultDesc, char[] ErrorBuf, int ErrorBufLen);
   
   int repc_create_result_param(WString FormName, WString ResultName, WString ResultDesc,
   int nParams, int[] pParamsNumbers, WString[] pParamsValues, char[] ErrorBuf, int ErrorBufLen);
   
   int repc_admin_setup(int bInterBase, WString ConnString, 
   WString User, WString Pass, WString ProjectName, WString DbName,
   WString DbLogin, WString DbPass, WString DbRole, int bVerify, int bShowErrorMess);
   
   int rcalc_alloc_handle();   
   int rcalc_copy_handle(int calc_handle);
   int rcalc_free_handle(int calc_handle);
   int rcalc_get_state(int calc_handle);
   int rcalc_is_valid(int calc_handle);
   int rcalc_is_compiled(int calc_handle);
   int rcalc_is_executed(int calc_handle);
   void rcalc_set_status_window(int calc_handle, int hStatWnd);
   int rcalc_compile(int calc_handle, WString Source);
   int rcalc_compile_file(int calc_handle, WString FileName, int Format);
   int rcalc_execute(int calc_handle, int nInput, WString[] pInputValues);
   int rcalc_execute2(int calc_handle, WString InputValues, WString Separator);
   int rcalc_get_input_count(int calc_handle);
   int rcalc_get_input_type(int calc_handle, int number);
   int rcalc_get_input_type_numscale(int calc_handle, int number);
   int rcalc_get_input_type_name_len(int calc_handle, int number);
   int rcalc_copy_input_type_name(int calc_handle, int number, char[] buf, int len);
   int rcalc_get_input_name_len(int calc_handle, int number);
   int rcalc_copy_input_name(int calc_handle, int number, char[] buf, int len);
   int rcalc_isnull_input(int calc_handle, int number);
   int rcalc_get_input_string_len(int calc_handle, int number);
   int rcalc_copy_input_string(int calc_handle, int number, char[] buf, int len);
   double rcalc_get_input_double(int calc_handle, int number);
   int rcalc_get_input_int(int calc_handle, int number);
   long rcalc_get_input_numeric(int calc_handle, int number);
   long rcalc_get_input_time(int calc_handle, int number);
   int rcalc_get_output_count(int calc_handle);
   int rcalc_get_compiled_text_len(int calc_handle, int bCRLF);
   int rcalc_copy_compiled_text(int calc_handle, int bCRLF, char[] buf, int len);
   int rcalc_get_output_type(int calc_handle, int number);
   int rcalc_get_output_type_textlen(int calc_handle, int number);
   int rcalc_get_output_type_numscale(int calc_handle, int number);
   int rcalc_get_output_type_name_len(int calc_handle, int number);
   int rcalc_copy_output_type_name(int calc_handle, int number, char[] buf, int len);
   int rcalc_get_output_name_len(int calc_handle, int number);
   int rcalc_copy_output_name(int calc_handle, int number, char[] buf, int len);
   int rcalc_isnull_output(int calc_handle, int number);
   int rcalc_get_output_string_len(int calc_handle, int number);
   int rcalc_copy_output_string(int calc_handle, int number, char[] buf, int len);
   double rcalc_get_output_double(int calc_handle, int number);
   int rcalc_get_output_int(int calc_handle, int number);
   long rcalc_get_output_numeric(int calc_handle, int number);
   long rcalc_get_output_time(int calc_handle, int number);
   int rcalc_get_year(long value);
   int rcalc_get_month(long value);
   int rcalc_get_day(long value);
   int rcalc_get_hour(long value);
   int rcalc_get_minute(long value);
   int rcalc_get_second(long value);
   int rcalc_get_millisec(long value);
   int rcalc_get_error_text_len();
   void rcalc_show_error(long hParent);
   int rcalc_copy_error_text(char[] buf, int len);   
  }

class Repcoder
 {
  static boolean init()
    {
     int ok = Repcoder_lib.INSTANCE.repc_init();
     return (ok == 1)? true: false;
    }
	
  static void exit()
    {
     Repcoder_lib.INSTANCE.repc_exit();
    }
		
  static boolean open_report(int hParent, boolean bModal, String FormName, int RecordSeqNr,
  int[] pParamsNumbers, String[] pParamsValues, boolean bParamsUpdate,
  boolean bRecNavigate, boolean bDesignMode, boolean bAllowDesign, boolean bAllowUpdate)
    {
     int modal = (bModal == true)? 1: 0;
     int paramsupdate = (bParamsUpdate == true)? 1: 0;
     int recnavigate = (bRecNavigate == true)? 1: 0;
     int designmode = (bDesignMode == true)? 1: 0;
     int allowdesign = (bAllowDesign == true)? 1: 0;
     int allowupdate = (bAllowUpdate == true)? 1: 0;
     
     int nParams = pParamsNumbers.length;
     if( pParamsValues.length < nParams ) nParams = pParamsValues.length;

     WString[] wt = null;
     if( pParamsValues != null && nParams > 0 )
       {
        wt = new WString[nParams];
        if( wt != null )
          {
           for(int i=0; i<wt.length; i++) wt[i] = new WString(pParamsValues[i]);
          }
       }
	 	
     int ok = Repcoder_lib.INSTANCE.repc_open_report(hParent, modal, new WString(FormName), RecordSeqNr,
     nParams, pParamsNumbers, wt, paramsupdate, recnavigate, designmode, allowdesign, allowupdate);

     return (ok == 1)? true: false;
    }

  static boolean open_report2(int hParent, boolean bModal, String FormName, int RecordSeqNr,
  String Parameters, boolean bParamsUpdate,
  boolean bRecNavigate, boolean bDesignMode, boolean bAllowDesign, boolean bAllowUpdate)
    {
     int modal = (bModal == true)? 1: 0;
     int paramsupdate = (bParamsUpdate == true)? 1: 0;
     int recnavigate = (bRecNavigate == true)? 1: 0;
     int designmode = (bDesignMode == true)? 1: 0;
     int allowdesign = (bAllowDesign == true)? 1: 0;
     int allowupdate = (bAllowUpdate == true)? 1: 0;
	 	
     int ok = Repcoder_lib.INSTANCE.repc_open_report2(hParent, modal, new WString(FormName), RecordSeqNr,
     new WString(Parameters), paramsupdate, recnavigate, designmode, allowdesign, allowupdate);

     return (ok == 1)? true: false;
    }
    
  static boolean call_report(int hParent, boolean bModal, String FormName, boolean bDesignMode)
    {	 
     int modal = (bModal == true)? 1: 0;
     int designmode = (bDesignMode == true)? 1: 0;
     int ok = Repcoder_lib.INSTANCE.repc_call_report(hParent, modal, new WString(FormName), designmode);
     return (ok == 1)? true: false;
    }
	
  static boolean call_report_param(int hParent, boolean bModal, String FormName, boolean bDesignMode, 
  int[] pParamsNumbers, String[] pParamsValues, boolean bParamsUpdate)
    {
     int modal = (bModal == true)? 1: 0;
     int designmode = (bDesignMode == true)? 1: 0;
     int paramsupdate = (bParamsUpdate == true)? 1: 0;
     
     int nParams = pParamsNumbers.length;
     if( pParamsValues.length < nParams ) nParams = pParamsValues.length;     
	
     WString[] wt = null;
     if( pParamsValues != null && nParams > 0 )
       {
        wt = new WString[nParams];
        if( wt != null )
          {
           for(int i=0; i<wt.length; i++) wt[i] = new WString(pParamsValues[i]);
          }
       }
    	 
     int ok = Repcoder_lib.INSTANCE.repc_call_report_param(hParent, modal, new WString(FormName), designmode, 
     nParams, pParamsNumbers, wt, paramsupdate);

     return (ok == 1)? true: false;
    }
	
  static boolean call_report_param2(int hParent, boolean bModal, String FormName, boolean bDesignMode, 
  String Parameters, boolean bParamsUpdate)
    {
     int modal = (bModal == true)? 1: 0;
     int designmode = (bDesignMode == true)? 1: 0;
     int paramsupdate = (bParamsUpdate == true)? 1: 0;
    	 
     int ok = Repcoder_lib.INSTANCE.repc_call_report_param2(hParent, modal, new WString(FormName), designmode, 
     new WString(Parameters), paramsupdate);

     return (ok == 1)? true: false;
    }
    
  static void explorer(int hParent, boolean bModal, String Dir, boolean bDesign, boolean bResultOnly)
    {
     int modal = (bModal == true)? 1: 0;
     int design = (bDesign == true)? 1: 0;
     int resultonly = (bResultOnly == true)? 1: 0;
	 
     Repcoder_lib.INSTANCE.repc_explorer(hParent, modal, new WString(Dir), design, resultonly);
    }
		
  static void explorer_param(int hParent, boolean bModal, String Dir, boolean bDesign, boolean bResultOnly,
  int[] pParamsNumbers, String[] pParamsValues, boolean bParamsUpdate)
    {
     int modal = (bModal == true)? 1: 0;
     int design = (bDesign == true)? 1: 0;
     int resultonly = (bResultOnly == true)? 1: 0;
     int paramsupdate = (bParamsUpdate == true)? 1: 0;
     
     int nParams = pParamsNumbers.length;
     if( pParamsValues.length < nParams ) nParams = pParamsValues.length;     
     	
     WString[] wt = null;
     if( pParamsValues != null && nParams > 0 )
       {
        wt = new WString[nParams];
        if( wt != null )
          {
           for(int i=0; i<wt.length; i++) wt[i] = new WString(pParamsValues[i]);
          }
       }
    	
     Repcoder_lib.INSTANCE.repc_explorer_param(hParent, modal, new WString(Dir), design,
     resultonly, nParams, pParamsNumbers, wt, paramsupdate);
    }
	
  static String get_report_desc(String FormName)
    {
     int n = Repcoder_lib.INSTANCE.repc_get_report_desc_len(new WString(FormName));

     String s = "";
     if( n <= 0 ) return s;

     char[] buf = new char[n+1];
     int ok = Repcoder_lib.INSTANCE.repc_get_report_desc(new WString(FormName), buf, n+1); 
     if( ok != 0 )
       {
        s = new String(buf);
        return s.trim();
       }
     else return s;
    }
	 	
  static int get_open_count()
    { 
     return Repcoder_lib.INSTANCE.repc_get_open_count();
    }
 
  static boolean can_exit()
    {
     int canexit = Repcoder_lib.INSTANCE.repc_can_exit();
     return (canexit == 1)? true: false;
    }	

  static void set_user(String User)
    {
     Repcoder_lib.INSTANCE.repc_set_user(new WString(User));
    }
	
  static void set_pass(String Pass)
    {
     Repcoder_lib.INSTANCE.repc_set_pass(new WString(Pass));
    }

  static void set_role(String Role)
    {
     Repcoder_lib.INSTANCE.repc_set_role(new WString(Role));
    }

  static void set_charset(String Charset)
    {
     Repcoder_lib.INSTANCE.repc_set_charset(new WString(Charset));
    }

  static void set_logo(String Logo, boolean bReplace)
    {
     int replace = (bReplace == true)? 1: 0;
     Repcoder_lib.INSTANCE.repc_set_logo(new WString(Logo), replace);	
    }
	
  static boolean get_demo()
    {
     int demo = Repcoder_lib.INSTANCE.repc_get_demo();
     return (demo == 1)? true: false;
    }

  static boolean set_demo(boolean bDemo)
    {
     int demo = (bDemo == true)? 1: 0;
     int old_demo = Repcoder_lib.INSTANCE.repc_set_demo(demo);
     return (old_demo == 1)? true: false;
    }

  static void set_bde_netdir(String dir)
    {
     Repcoder_lib.INSTANCE.repc_set_bde_netdir(new WString(dir));	
    }
	
  static void set_fbclient_thread_safe(boolean bSafe)
    {
     int safe = (bSafe == true)? 1: 0;
     Repcoder_lib.INSTANCE.repc_set_fbclient_thread_safe(safe);
    }

  static void set_ibclient_thread_safe(boolean bSafe)
    {
     int safe = (bSafe == true)? 1: 0;
     Repcoder_lib.INSTANCE.repc_set_ibclient_thread_safe(safe);
    }

  static void set_dialog_fonts(int Type)
    {
     Repcoder_lib.INSTANCE.repc_set_dialog_fonts(Type);
    }
    
  static void set_user_interface_lang(int Lang)
    {
     Repcoder_lib.INSTANCE.repc_set_user_interface_lang(Lang);
    }

  static String create_result(String FormName, String ResultName, String ResultDesc)
   {
    char[] ErrorBuf = new char[2048];
    int ErrorBufLen = 2048;
    
    int ok = Repcoder_lib.INSTANCE.repc_create_result(new WString(FormName), new WString(ResultName),
    new WString(ResultDesc), ErrorBuf, ErrorBufLen);

    String s = "";
    if( ok == 1 ) return s;
    
    s = new String(ErrorBuf);
    return s.trim();
   }  
    
  static String create_result_param(String FormName, String ResultName, String ResultDesc,
  int[] pParamsNumbers, String[] pParamsValues)
   {
    char[] ErrorBuf = new char[2048];
    int ErrorBufLen = 2048;

    int nParams = pParamsNumbers.length;
    if( pParamsValues.length < nParams ) nParams = pParamsValues.length;     

    WString[] wt = null;
    if( pParamsValues != null && nParams > 0 )
      {
       wt = new WString[nParams];
       if( wt != null )
         {
          for(int i=0; i<wt.length; i++) wt[i] = new WString(pParamsValues[i]);
         }
      }
    
    int ok = Repcoder_lib.INSTANCE.repc_create_result_param(new WString(FormName), new WString(ResultName),
    new WString(ResultDesc), nParams, pParamsNumbers, wt, ErrorBuf, ErrorBufLen);

    String s = "";
    if( ok == 1 ) return s;
    
    s = new String(ErrorBuf);
    return s.trim();
   }  
    
  static boolean admin_setup(boolean bInterBase, String ConnString, String User, String Pass,
  String ProjectName, String DbName, String DbLogin, String DbPass, String DbRole, 
  boolean bVerify, boolean bShowErrorMess)
   {
    int interbase = (bInterBase == true)? 1: 0;
    int verify = (bVerify == true)? 1: 0;
    int showerrormess = (bShowErrorMess == true)? 1: 0;
    
    int ok = Repcoder_lib.INSTANCE.repc_admin_setup(interbase, new WString(ConnString), new WString(User), 
    new WString(Pass), new WString(ProjectName), new WString(DbName), new WString(DbLogin), new WString(DbPass),
    new WString(DbRole), verify, showerrormess);
    
    return (ok == 1)? true: false;
   }       
 }

class RCALC
{
int Handle;

public RCALC()
  {
   Handle = Repcoder_lib.INSTANCE.rcalc_alloc_handle();
  }

public RCALC(RCALC rc)
  {
   Handle = Repcoder_lib.INSTANCE.rcalc_copy_handle(rc.Handle);
  }

public boolean Free()
  {
   if( Handle > 0 )
     {
      int ok = Repcoder_lib.INSTANCE.rcalc_free_handle(Handle);
      if( ok == 1 ) Handle = 0;
      return (ok == 1)? true: false;
     }
   else return false;
  }

public boolean CopyFrom(RCALC rc)
  {
   if( Handle == rc.Handle ) return false;
   
   if( Handle > 0 ) 
     {
      int ok = Repcoder_lib.INSTANCE.rcalc_free_handle(Handle);
      if( ok == 1 ) 
        {
         Handle = Repcoder_lib.INSTANCE.rcalc_copy_handle(rc.Handle);
         return (Handle > 0);
        }
      else return false;
     }
   else return false;
  }

public int GetHandle()
  {
   return Handle;
  }

public int GetState()
  {
   if( Handle <= 0 ) return 0;
   return Repcoder_lib.INSTANCE.rcalc_get_state(Handle);
  }
  
public boolean IsValid()
  {
   if( Handle <= 0 ) return false;
   return (Repcoder_lib.INSTANCE.rcalc_is_valid(Handle) == 1)? true: false;
  }
  
public boolean IsCompiled()
  {
   if( Handle <= 0 ) return false;
   return (Repcoder_lib.INSTANCE.rcalc_is_compiled(Handle) == 1)? true: false;
  }
  
public boolean IsExecuted()
  {
   if( Handle <= 0 ) return false;
   return (Repcoder_lib.INSTANCE.rcalc_is_executed(Handle) == 1)? true: false;
  }

public void SetStatusWindow(int hStatWnd)
  {
   if( Handle <= 0 ) return;
   Repcoder_lib.INSTANCE.rcalc_set_status_window(Handle, hStatWnd);
  }

public boolean Compile(String Source)
  {
   if( Handle <= 0 ) return false;
   int ok = Repcoder_lib.INSTANCE.rcalc_compile(Handle, new WString(Source));
   return (ok == 1)? true: false;
  }

public boolean CompileFile(String FileName, int Format)
  {
   if( Handle <= 0 ) return false;
   int ok = Repcoder_lib.INSTANCE.rcalc_compile_file(Handle, new WString(FileName), Format);   
   return (ok == 1)? true: false;
  }

public boolean Execute(String[] InputValues)
  {
   if( Handle <= 0 ) return false;

   WString[] wt = null;
   if( InputValues != null && InputValues.length > 0 )
     {
      wt = new WString[InputValues.length];
      if( wt != null )
        {
         for(int i=0; i<wt.length; i++) wt[i] = new WString(InputValues[i]);
        }
     }

   int ok = Repcoder_lib.INSTANCE.rcalc_execute(Handle, wt.length, wt);
   return (ok == 1)? true: false;
  }

public boolean Execute(String InputValues, String Separator)
  {
   if( Handle <= 0 ) return false;
   int ok = Repcoder_lib.INSTANCE.rcalc_execute2(Handle, new WString(InputValues), new WString(Separator));
   return (ok == 1)? true: false;
  }

public boolean Execute(String InputValues)
  {
   return Execute(InputValues, "###");
  }

public boolean Execute()
  {
   return Execute("", "");
  }

public int InputCount()
  {
   if( Handle <= 0 ) return 0;
   return Repcoder_lib.INSTANCE.rcalc_get_input_count(Handle);
  }

public int InputType(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;
   return Repcoder_lib.INSTANCE.rcalc_get_input_type(Handle, number);
  }

public int InputTypeNumericScale(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;
   return Repcoder_lib.INSTANCE.rcalc_get_input_type_numscale(Handle, number);
  }

public String InputTypeName(int number)
  {
   String s = "";
   if( Handle <= 0 || number <= 0 ) return s;
   
   int n = Repcoder_lib.INSTANCE.rcalc_get_input_type_name_len(Handle, number);
   if( n <= 0 ) return s;

   char[] buf = new char[n+1];

   int ok = Repcoder_lib.INSTANCE.rcalc_copy_input_type_name(Handle, number, buf, n+1);
   if( ok != 0 )
     {
      for(int i=0; i<n+1; i++)
        {
         if( buf[i] == 0 ) buf[i] = ' ';
        }
       
      s = new String(buf);
      return s.trim();
     }
   else return s;
  }

public String InputName(int number)
  {
   String s = "";
   if( Handle <= 0 || number <= 0 ) return s;
   
   int n = Repcoder_lib.INSTANCE.rcalc_get_input_name_len(Handle, number);
   if( n <= 0 ) return s;
   
   char[] buf = new char[n+1];
     
   int ok = Repcoder_lib.INSTANCE.rcalc_copy_input_name(Handle, number, buf, n+1);	 
   if( ok != 0 )
     {
      s = new String(buf);
      return s.trim();
     }
   else return s;   
  }

public boolean InputIsNull(int number)
  {
   if( Handle <= 0 || number <= 0 ) return true;
   int ok = Repcoder_lib.INSTANCE.rcalc_isnull_input(Handle, number);
   return (ok == 1)? true: false;
  }

public String InputString(int number)
  {
   String s = "";
   if( Handle <= 0 || number <= 0 ) return s;
   
   int n = Repcoder_lib.INSTANCE.rcalc_get_input_string_len(Handle, number);
   if( n <= 0 ) return s;
   
   char[] buf = new char[n+1];
     
   int ok = Repcoder_lib.INSTANCE.rcalc_copy_input_string(Handle, number, buf, n+1);	 
   if( ok != 0 )
     {
      s = new String(buf);
      return s.trim();
     }
   else return s;
  }

public double InputDouble(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;
   return Repcoder_lib.INSTANCE.rcalc_get_input_double(Handle, number);
  }

public int InputInt(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;
   return Repcoder_lib.INSTANCE.rcalc_get_input_int(Handle, number);
  }

public long InputNumeric(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;
   return Repcoder_lib.INSTANCE.rcalc_get_input_numeric(Handle, number);
  }

public long InputTime(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;
   return Repcoder_lib.INSTANCE.rcalc_get_input_time(Handle, number);
  }

public int OutputCount()
  {
   if( Handle <= 0 ) return 0;
   return Repcoder_lib.INSTANCE.rcalc_get_output_count(Handle);
  }

public String CompiledText(boolean bCRLF)
  {
   String s = "";
   if( Handle <= 0 ) return s;
   
   int bCR = (bCRLF)? 1: 0;
   
   int n = Repcoder_lib.INSTANCE.rcalc_get_compiled_text_len(Handle, bCR);   
   if( n <= 0 ) return s;
   
   char[] buf = new char[n+1];
     
   int ok = Repcoder_lib.INSTANCE.rcalc_copy_compiled_text(Handle, bCR, buf, n+1);	 
   if( ok != 0 )
     {
      s = new String(buf);
      return s.trim();
     }
   else return s;
  }

public int OutType(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;
   return Repcoder_lib.INSTANCE.rcalc_get_output_type(Handle, number);
  }

public int OutTypeTextLen(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;
   return Repcoder_lib.INSTANCE.rcalc_get_output_type_textlen(Handle, number);
  }

public int OutTypeNumericScale(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;
   return Repcoder_lib.INSTANCE.rcalc_get_output_type_numscale(Handle, number);
  }

public String OutTypeName(int number)
  {
   String s = "";
   if( Handle <= 0 || number <= 0 ) return s;
   
   int n = Repcoder_lib.INSTANCE.rcalc_get_output_type_name_len(Handle, number);
   if( n <= 0 ) return s;

   char[] buf = new char[n+1];

   int ok = Repcoder_lib.INSTANCE.rcalc_copy_output_type_name(Handle, number, buf, n+1);
   if( ok != 0 )
     {
      s = new String(buf);
      return s.trim();
     }
   else return s;
  }

public String OutName(int number)
  {
   String s = "";
   if( Handle <= 0 || number <= 0 ) return s;
   
   int n = Repcoder_lib.INSTANCE.rcalc_get_output_name_len(Handle, number);
   if( n <= 0 ) return s;
   
   char[] buf = new char[n+1];
     
   int ok = Repcoder_lib.INSTANCE.rcalc_copy_output_name(Handle, number, buf, n+1);
   if( ok != 0 )
     {
      s = new String(buf);
      return s.trim();
     }
   else return s;   
  }

public boolean OutIsNull(int number)
  {
   if( Handle <= 0 || number <= 0 ) return true;
   int ok = Repcoder_lib.INSTANCE.rcalc_isnull_output(Handle, number);
   return (ok == 1)? true: false;
  }

public String OutString(int number)
  {
   String s = "";
   if( Handle <= 0 || number <= 0 ) return s;
   
   int n = Repcoder_lib.INSTANCE.rcalc_get_output_string_len(Handle, number);
   if( n <= 0 ) return s;
   
   char[] buf = new char[n+1];
     
   int ok = Repcoder_lib.INSTANCE.rcalc_copy_output_string(Handle, number, buf, n+1);	 
   if( ok != 0 )
     {
      s = new String(buf);
      return s.trim();
     }
   else return s;
  }

public double OutDouble(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;
   return Repcoder_lib.INSTANCE.rcalc_get_output_double(Handle, number);
  }

public int OutInt(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;
   return Repcoder_lib.INSTANCE.rcalc_get_output_int(Handle, number);
  }

public long OutNumeric(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;
   return Repcoder_lib.INSTANCE.rcalc_get_output_numeric(Handle, number);
  }

public long OutTime(int number)
  {
   if( Handle <= 0 || number <= 0 ) return 0;
   return Repcoder_lib.INSTANCE.rcalc_get_output_time(Handle, number);
  }

public static int Year(long value) { return Repcoder_lib.INSTANCE.rcalc_get_year(value); }
public static int Month(long value) { return Repcoder_lib.INSTANCE.rcalc_get_month(value); }
public static int Day(long value) { return Repcoder_lib.INSTANCE.rcalc_get_day(value); }
public static int Hour(long value) { return Repcoder_lib.INSTANCE.rcalc_get_hour(value); }
public static int Minute(long value) { return Repcoder_lib.INSTANCE.rcalc_get_minute(value); }
public static int Second(long value) { return Repcoder_lib.INSTANCE.rcalc_get_second(value); }
public static int Millisec(long value) { return Repcoder_lib.INSTANCE.rcalc_get_millisec(value); }

public static boolean LastError()
  {
   int n = Repcoder_lib.INSTANCE.rcalc_get_error_text_len();
   return (n>0) ? true: false;
  }
  
public static void ShowError(int hParent)
  {
   Repcoder_lib.INSTANCE.rcalc_show_error(hParent);
  }
  
public static String ErrorString()
  {
   int n = Repcoder_lib.INSTANCE.rcalc_get_error_text_len();

   String s = "";
   if( n <= 0 ) return s;

   char[] buf = new char[n+1];
     
   int ok = Repcoder_lib.INSTANCE.rcalc_copy_error_text(buf, n+1);	 
   if( ok != 0 )
     {
      s = new String(buf);
      return s.trim();
     }
   else return s;
  }

}
