
unit REPCODER;

interface
uses sysutils, windows;

{$IFNDEF _REPCODER_H}
{$DEFINE _REPCODER_H}

// REPCoder

var repc_init: function: Bool stdcall;
var repc_exit: procedure stdcall;

var repc_open_report:
function(hParent: HWND;
bModal: Bool;
FormName: WideString;
RecordSeqNr: Integer;
nParams: Integer;
pParamsNumbers: PInteger;
pParamsValues: PWideString;
bParamsUpdate: Bool;
bRecNavigate: Bool;
bDesignMode: Bool;
bAllowDesign: Bool;
bAllowUpdate: Bool): Integer stdcall;

var repc_open_report_a:
function(hParent: HWND;
bModal: Bool;
FormName: AnsiString;
RecordSeqNr: Integer;
nParams: Integer;
pParamsNumbers: PInteger;
pParamsValues: PAnsiString;
bParamsUpdate: Bool;
bRecNavigate: Bool;
bDesignMode: Bool;
bAllowDesign: Bool;
bAllowUpdate: Bool): Integer stdcall;

var repc_open_report2:
function(hParent: HWND;
bModal: Bool;
FormName: WideString;
RecordSeqNr: Integer;
Parameters: WideString;
bParamsUpdate: Bool;
bRecNavigate: Bool;
bDesignMode: Bool;
bAllowDesign: Bool;
bAllowUpdate: Bool): Integer stdcall;

var repc_open_report2_a:
function(hParent: HWND;
bModal: Bool;
FormName: AnsiString;
RecordSeqNr: Integer;
Parameters: AnsiString;
bParamsUpdate: Bool;
bRecNavigate: Bool;
bDesignMode: Bool;
bAllowDesign: Bool;
bAllowUpdate: Bool): Integer stdcall;

var repc_call_report:
function(hParent: HWND;
bModal: Bool;
FormName: WideString;
bDesignMode: Bool): Integer stdcall;

var repc_call_report_a:
function(hParent: HWND;
bModal: Bool;
FormName: AnsiString;
bDesignMode: Bool): Integer stdcall;

var repc_call_report_param:
function(hParent: HWND;
bModal: Bool;
FormName: WideString;
bDesignMode: Bool;
nParams: Integer;
pParamsNumbers: PInteger;
pParamsValues: PWideString;
bParamsUpdate: Bool): Integer stdcall;

var repc_call_report_param_a:
function(hParent: HWND;
bModal: Bool;
FormName: AnsiString;
bDesignMode: Bool;
nParams: Integer;
pParamsNumbers: PInteger;
pParamsValues: PAnsiString;
bParamsUpdate: Bool): Integer stdcall;

var repc_call_report_param2:
function(hParent: HWND;
bModal: Bool;
FormName: WideString;
bDesignMode: Bool;
Parameters: WideString;
bParamsUpdate: Bool): Integer stdcall;

var repc_call_report_param2_a:
function(hParent: HWND;
bModal: Bool;
FormName: AnsiString;
bDesignMode: Bool;
Parameters: AnsiString;
bParamsUpdate: Bool): Integer stdcall;

var repc_explorer:
procedure(hParent: HWND;
bModal: Bool;
Dir: WideString;
bDesign: Bool;
bResultOnly: Bool) stdcall;

var repc_explorer_a:
procedure(hParent: HWND;
bModal: Bool;
Dir: AnsiString;
bDesign: Bool;
bResultOnly: Bool) stdcall;

var repc_explorer_param:
procedure(hParent: HWND;
bModal: Bool;
Dir: WideString;
bDesign: Bool;
bResultOnly: Bool;
nParams: Integer;
pParamsNumbers: PInteger;
pParamsValues: PWideString;
bParamsUpdate: Bool) stdcall;

var repc_explorer_param_a:
procedure(hParent: HWND;
bModal: Bool;
Dir: AnsiString;
bDesign: Bool;
bResultOnly: Bool;
nParams: Integer;
pParamsNumbers: PInteger;
pParamsValues: PAnsiString;
bParamsUpdate: Bool) stdcall;

var repc_get_report_desc_len: function(FormName: WideString): Integer stdcall;
var repc_get_report_desc: function(FormName: WideString; buf: PWideChar; len: Integer): Bool stdcall;
var repc_get_report_desc_a: function(FormName: AnsiString; buf: PChar; len: Integer): Bool stdcall;

var repc_alloc_report_desc: function(FormName: WideString): PWideChar stdcall;
var repc_alloc_report_desc_a: function(FormName: AnsiString): PChar stdcall;
var repc_free_memory: procedure(ptr: Pointer) stdcall;

var repc_get_open_count: function: Integer stdcall;
var repc_can_exit: function: Bool stdcall;
var repc_set_user: procedure(User: WideString) stdcall;
var repc_set_user_a: procedure(User: AnsiString) stdcall;
var repc_set_pass: procedure(Pass: WideString) stdcall;
var repc_set_pass_a: procedure(Pass: AnsiString) stdcall;
var repc_set_role: procedure(Role: WideString) stdcall;
var repc_set_role_a: procedure(Role: AnsiString) stdcall;
var repc_set_charset: procedure(CharSet: WideString) stdcall;
var repc_set_charset_a: procedure(CharSet: AnsiString) stdcall;
var repc_set_logo: procedure(szLogo: WideString; bReplace: Bool) stdcall;
var repc_set_logo_a: procedure(szLogo: AnsiString; bReplace: Bool) stdcall;
var repc_get_demo: function: Bool stdcall;
var repc_set_demo: function(bDemo: Bool): Bool stdcall;
var repc_set_bde_netdir: procedure(dir: WideString) stdcall;
var repc_set_bde_netdir_a: procedure(dir: AnsiString) stdcall;
var repc_set_fbclient_thread_safe: procedure(bSafe: Bool) stdcall;
var repc_set_ibclient_thread_safe: procedure(bSafe: Bool) stdcall;
var repc_set_dialog_fonts: procedure(font_type: Integer) stdcall;
var repc_set_user_interface_lang: procedure(Lang: Integer) stdcall;

var repc_create_result:
function(
FormName: WideString;
ResultName: WideString;
ResultDesc: WideString;
ErrorBuf: PWideChar;
ErrorBufLen: Integer): Bool stdcall;

var repc_create_result_a:
function(
FormName: AnsiString;
ResultName: AnsiString;
ResultDesc: AnsiString;
ErrorBuf: PChar;
ErrorBufLen: Integer): Bool stdcall;
  
var repc_create_result_param:
function(
FormName: WideString;
ResultName: WideString;
ResultDesc: WideString;
nParams: Integer;
pParamsNumbers: PInteger;
pParamsValues: PWideString;
ErrorBuf: PWideChar;
ErrorBufLen: Integer): Bool stdcall;

var repc_create_result_param_a:
function(
FormName: AnsiString;
ResultName: AnsiString;
ResultDesc: AnsiString;
nParams: Integer;
pParamsNumbers: PInteger;
pParamsValues: PAnsiString;
ErrorBuf: PChar;
ErrorBufLen: Integer): Bool stdcall;

var repc_admin_setup:
function(
bInterBase: Bool;
ConnString: WideString;
User: WideString;
Pass: WideString;
ProjectName: WideString;
DbName: WideString;
DbLogin: WideString;
DbPass: WideString;
DbRole: WideString;
bVerify: Bool;
bShowErrorMess: Bool): Bool stdcall;
  
var repc_admin_setup_a:
function(
bInterBase: Bool;
ConnString: AnsiString;
User: AnsiString;
Pass: AnsiString;
ProjectName: AnsiString;
DbName: AnsiString;
DbLogin: AnsiString;
DbPass: AnsiString;
DbRole: AnsiString;
bVerify: Bool;
bShowErrorMess: Bool): Bool stdcall;

// Global functions:
function ReportDesc(FormName: WideString): WideString;
function ReportDescA(FormName: AnsiString): AnsiString;
function CreateReportResult(FormName: WideString; ResultName: WideString; ResultDesc: WideString): WideString;
function CreateReportResultA(FormName: AnsiString; ResultName: AnsiString; ResultDesc: AnsiString): AnsiString;

function CreateReportResultParam(FormName: WideString; ResultName: WideString; ResultDesc: WideString;
nParams: Integer; pParamsNumbers: PInteger; pParamsValues: PWideString): WideString;

function CreateReportResultParamA(FormName: AnsiString; ResultName: AnsiString; ResultDesc: AnsiString;
nParams: Integer; pParamsNumbers: PInteger; pParamsValues: PAnsiString): AnsiString;

// RCALC
var rcalc_alloc_handle: function: Integer stdcall;
var rcalc_copy_handle: function(calc_handle: Integer): Integer stdcall;
var rcalc_free_handle: function(calc_handle: Integer): Bool stdcall;
var rcalc_free_all_handles: function: Bool stdcall;
var rcalc_get_state: function(calc_handle: Integer): Integer stdcall;
var rcalc_is_valid: function(calc_handle: Integer): Bool stdcall;
var rcalc_is_compiled: function(calc_handle: Integer): Bool stdcall;
var rcalc_is_executed: function(calc_handle: Integer): Bool stdcall;
var rcalc_set_status_window: procedure(calc_handle: Integer; hStatWnd: HWND) stdcall;
var rcalc_compile: function(calc_handle: Integer; pText: WideString): Bool stdcall;
var rcalc_compile_a: function(calc_handle: Integer; pText: AnsiString): Bool stdcall;
var rcalc_compile_file: function(calc_handle: Integer; FileName: WideString; Format: Integer): Bool stdcall;
var rcalc_compile_file_a: function(calc_handle: Integer; FileName: AnsiString; Format: Integer): Bool stdcall;
var rcalc_show_error: procedure(hParent: HWND) stdcall;
var rcalc_get_error_text_len: function: Integer stdcall;
var rcalc_copy_error_text: function(buf: PWideChar; len: Integer): Bool stdcall;
var rcalc_copy_error_text_a: function(buf: PChar; len: Integer): Bool stdcall;
var rcalc_alloc_error_text: function: PWideChar stdcall;
var rcalc_alloc_error_text_a: function: PChar stdcall;
var rcalc_get_compiled_text_len: function(calc_handle: Integer; bCRLF: Bool): Integer stdcall;
var rcalc_copy_compiled_text: function(calc_handle: Integer; bCRLF: Bool; buf: PWideChar; len: Integer): Bool stdcall;
var rcalc_copy_compiled_text_a: function(calc_handle: Integer; bCRLF: Bool; buf: PChar; len: Integer): Bool stdcall;
var rcalc_get_compiled_text: function(calc_handle: Integer; bCRLF: Bool): PWideChar stdcall;
var rcalc_get_compiled_text_a: function(calc_handle: Integer; bCRLF: Bool): PChar stdcall;
var rcalc_execute: function(calc_handle: Integer; nInput: Integer; pInputValues: PWideString): Bool stdcall;
var rcalc_execute_a: function(calc_handle: Integer; nInput: Integer; pInputValues: PAnsiString): Bool stdcall;
var rcalc_execute2: function(calc_handle: Integer; InputValues: WideString; Separator: WideString): Bool stdcall;
var rcalc_execute2_a: function(calc_handle: Integer; InputValues: AnsiString; Separator: AnsiString): Bool stdcall;
var rcalc_get_input_count: function(calc_handle: Integer): Integer stdcall;
var rcalc_get_input_name_len: function(calc_handle: Integer; number: Integer): Integer stdcall;
var rcalc_copy_input_name: function(calc_handle: Integer; number: Integer; buf: PWideChar; len: Integer): Bool stdcall;
var rcalc_copy_input_name_a: function(calc_handle: Integer; number: Integer; buf: PChar; len: Integer): Bool stdcall;
var rcalc_get_input_name: function(calc_handle: Integer; number: Integer): PWideChar stdcall;
var rcalc_get_input_name_a: function(calc_handle: Integer; number: Integer): PChar stdcall;
var rcalc_get_input_number: function(calc_handle: Integer; name: WideString): Integer stdcall;
var rcalc_get_input_number_a: function(calc_handle: Integer; name: AnsiString): Integer stdcall;
var rcalc_get_input_type: function(calc_handle: Integer; number: Integer): Integer stdcall;
var rcalc_get_input_type_numscale: function(calc_handle: Integer; number: Integer): Integer stdcall;
var rcalc_get_input_type_name_len: function(calc_handle: Integer; number: Integer): Integer stdcall;
var rcalc_copy_input_type_name: function(calc_handle: Integer; number: Integer; buf: PWideChar; len: Integer): Bool stdcall;
var rcalc_copy_input_type_name_a: function(calc_handle: Integer; number: Integer; buf: PChar; len: Integer): Bool stdcall;
var rcalc_get_input_type_name: function(calc_handle: Integer; number: Integer): PWideChar stdcall;
var rcalc_get_input_type_name_a: function(calc_handle: Integer; number: Integer): PChar stdcall;
var rcalc_get_output_count: function(calc_handle: Integer): Integer stdcall;
var rcalc_get_output_name_len: function(calc_handle: Integer; number: Integer): Integer stdcall;
var rcalc_copy_output_name: function(calc_handle: Integer; number: Integer; buf: PWideChar; len: Integer): Bool stdcall;
var rcalc_copy_output_name_a: function(calc_handle: Integer; number: Integer; buf: PChar; len: Integer): Bool stdcall;
var rcalc_get_output_name: function(calc_handle: Integer; number: Integer): PWideChar stdcall;
var rcalc_get_output_name_a: function(calc_handle: Integer; number: Integer): PChar stdcall;
var rcalc_get_output_number: function(calc_handle: Integer; name: WideString): Integer stdcall;
var rcalc_get_output_number_a: function(calc_handle: Integer; name: AnsiString): Integer stdcall;
var rcalc_get_output_type: function(calc_handle: Integer; number: Integer): Integer stdcall;
var rcalc_get_output_type_textlen: function(calc_handle: Integer; number: Integer): Integer stdcall;
var rcalc_get_output_type_numscale: function(calc_handle: Integer; number: Integer): Integer stdcall;
var rcalc_get_output_type_name_len: function(calc_handle: Integer; number: Integer): Integer stdcall;
var rcalc_copy_output_type_name: function(calc_handle: Integer; number: Integer; buf: PWideChar; len: Integer): Bool stdcall;
var rcalc_copy_output_type_name_a: function(calc_handle: Integer; number: Integer; buf: PChar; len: Integer): Bool stdcall;
var rcalc_get_output_type_name: function(calc_handle: Integer; number: Integer): PWideChar stdcall;
var rcalc_get_output_type_name_a: function(calc_handle: Integer; number: Integer): PChar stdcall;
var rcalc_isnull_input: function(calc_handle: Integer; number: Integer): Bool stdcall;
var rcalc_get_input_string: function(calc_handle: Integer; number: Integer): PWideChar stdcall;
var rcalc_get_input_string_a: function(calc_handle: Integer; number: Integer): PChar stdcall;
var rcalc_get_input_string_len: function(calc_handle: Integer; number: Integer): Integer stdcall;
var rcalc_copy_input_string: function(calc_handle: Integer; number: Integer; buf: PWideChar; len: Integer): Integer stdcall;
var rcalc_copy_input_string_a: function(calc_handle: Integer; number: Integer; buf: PChar; len: Integer): Integer stdcall;
var rcalc_get_input_double: function(calc_handle: Integer; number: Integer): Double stdcall;
var rcalc_get_input_int: function(calc_handle: Integer; number: Integer): Integer stdcall;
var rcalc_get_input_numeric: function(calc_handle: Integer; number: Integer): Int64 stdcall;
var rcalc_get_input_time: function(calc_handle: Integer; number: Integer): Int64 stdcall;
var rcalc_isnull_output: function(calc_handle: Integer; number: Integer): Bool stdcall;
var rcalc_get_output_string: function(calc_handle: Integer; number: Integer): PWideChar stdcall;
var rcalc_get_output_string_a: function(calc_handle: Integer; number: Integer): PChar stdcall;
var rcalc_get_output_string_len: function(calc_handle: Integer; number: Integer): Integer stdcall;
var rcalc_copy_output_string: function(calc_handle: Integer; number: Integer; buf: PWideChar; len: Integer): Integer stdcall;
var rcalc_copy_output_string_a: function(calc_handle: Integer; number: Integer; buf: PChar; len: Integer): Integer stdcall;
var rcalc_get_output_double: function(calc_handle: Integer; number: Integer): Double stdcall;
var rcalc_get_output_int: function(calc_handle: Integer; number: Integer): Integer stdcall;
var rcalc_get_output_numeric: function(calc_handle: Integer; number: Integer): Int64 stdcall;
var rcalc_get_output_time: function(calc_handle: Integer; number: Integer): Int64 stdcall;
var rcalc_get_year: function(value: Int64): Integer stdcall;
var rcalc_get_month: function(value: Int64): Integer stdcall;
var rcalc_get_day: function(value: Int64): Integer stdcall;
var rcalc_get_hour: function(value: Int64): Integer stdcall;
var rcalc_get_minute: function(value: Int64): Integer stdcall;
var rcalc_get_second: function(value: Int64): Integer stdcall;
var rcalc_get_millisec: function(value: Int64): Integer stdcall;

// RCALC class
type
  RCALC = class

  private
  Handle: Integer;

  public

  constructor Create; overload;
  constructor Create(rc: RCALC); overload;
  destructor  Destroy; override;
  
  function CopyFrom(rc: RCALC): Boolean;
  function GetHandle: Integer;
  function GetState: Integer;
  function IsValid: Boolean;
  function IsCompiled: Boolean;
  function IsExecuted: Boolean;
  procedure SetStatusWindow(hStatWnd: HWND);
  
  function Compile(Source: WideString): Boolean; overload;
  function Compile(Source: AnsiString): Boolean; overload;
  function CompileFile(Source: WideString; Format: Integer): Boolean; overload;
  function CompileFile(Source: AnsiString; Format: Integer): Boolean; overload;
  
  function Execute(nInput: Integer; pInputValues: PWideString): Boolean; overload;
  function ExecuteA(nInput: Integer; pInputValues: PAnsiString): Boolean; overload;
  function Execute(InputValues: WideString; Separator: WideString): Boolean; overload;
  function ExecuteA(InputValues: AnsiString; Separator: AnsiString): Boolean; overload;
  function Execute(InputValues: WideString): Boolean; overload;
  function ExecuteA(InputValues: AnsiString): Boolean; overload;
  function Execute: Boolean; overload;
  
  function CompiledText(bCRLF: Boolean): WideString;
  function CompiledTextA(bCRLF: Boolean): AnsiString;
  
  function InputCount: Integer;
  function InputType(number: Integer): Integer;
  function InputTypeNumericScale(number: Integer): Integer;
  function InputTypeName(number: Integer): WideString;
  function InputTypeNameA(number: Integer): AnsiString;
  function InputName(number: Integer): WideString;
  function InputNameA(number: Integer): AnsiString;
  function InputIsNull(number: Integer): Boolean;
  function InputString(number: Integer): WideString;
  function InputStringA(number: Integer): AnsiString;
  function InputDouble(number: Integer): Double;
  function InputInt(number: Integer): Integer;
  function InputNumeric(number: Integer): Int64;
  function InputTime(number: Integer): Int64;
  
  function OutputCount: Integer;
  function OutType(number: Integer): Integer;
  function OutTypeTextLen(number: Integer): Integer;
  function OutTypeNumericScale(number: Integer): Integer;
  function OutTypeName(number: Integer): WideString;
  function OutTypeNameA(number: Integer): AnsiString;
  function OutName(number: Integer): WideString;
  function OutNameA(number: Integer): AnsiString;
  function OutIsNull(number: Integer): Boolean;
  function OutString(number: Integer): WideString;
  function OutStringA(number: Integer): AnsiString;
  function OutDouble(number: Integer): Double;
  function OutInt(number: Integer): Integer;
  function OutNumeric(number: Integer): Int64;
  function OutTime(number: Integer): Int64;  
end;
//------------------

// RCALC global functions:
function RCALC_Year(value: Int64): Integer;
function RCALC_Month(value: Int64): Integer;
function RCALC_Day(value: Int64): Integer;
function RCALC_Hour(value: Int64): Integer;
function RCALC_Minute(value: Int64): Integer;
function RCALC_Second(value: Int64): Integer;
function RCALC_Millisec(value: Int64): Integer;
function RCALC_LastError: Boolean;
procedure RCALC_ShowError(hParent: HWND);
function RCALC_ErrorString: WideString;
function RCALC_ErrorStringA: AnsiString;
//------------------

{$ENDIF}

var DLLLoaded: Boolean = False;

implementation

var
  SaveExit: pointer;
  DLLHandle: THandle;
{$IFNDEF MSDOS}
  ErrorMode: Integer;
{$ENDIF}
//------------------

function ReportDesc(FormName: WideString): WideString;
var ptr: PWideChar;
begin
  ptr := repc_alloc_report_desc(FormName);
  Result := ptr;
  repc_free_memory(ptr);
end;
//------------------

function ReportDescA(FormName: AnsiString): AnsiString;
var ptr: PChar;
begin
  ptr := repc_alloc_report_desc_a(FormName);
  Result := ptr;
  repc_free_memory(ptr);
end;
//------------------

function CreateReportResult(FormName: WideString; ResultName: WideString; ResultDesc: WideString): WideString;
var ErrorBuf: Array[0..2048] of WideChar;
var ok: Boolean;
begin
  ok := repc_create_result(FormName, ResultName, ResultDesc, ErrorBuf, 2048);
  if ok = True then Result := ''
  else Result := ErrorBuf;
end;
//------------------

function CreateReportResultA(FormName: AnsiString; ResultName: AnsiString; ResultDesc: AnsiString): AnsiString;
var ErrorBuf: Array[0..2048] of Char;
var ok: Boolean;
begin
  ok := repc_create_result_a(FormName, ResultName, ResultDesc, ErrorBuf, 2048);
  if ok = True then Result := ''
  else Result := ErrorBuf;
end;
//------------------

function CreateReportResultParam(FormName: WideString; ResultName: WideString; ResultDesc: WideString;
nParams: Integer; pParamsNumbers: PInteger; pParamsValues: PWideString): WideString;
var ErrorBuf: Array[0..2048] of WideChar;
var ok: Boolean;
begin
  ok := repc_create_result_param(FormName, ResultName, ResultDesc, nParams, pParamsNumbers, pParamsValues, ErrorBuf, 2048);
  if ok = True then Result := ''
  else Result := ErrorBuf;
end;
//------------------

function CreateReportResultParamA(FormName: AnsiString; ResultName: AnsiString; ResultDesc: AnsiString;
nParams: Integer; pParamsNumbers: PInteger; pParamsValues: PAnsiString): AnsiString;
var ErrorBuf: Array[0..2048] of Char;
var ok: Boolean;
begin
  ok := repc_create_result_param_a(FormName, ResultName, ResultDesc, nParams, pParamsNumbers, pParamsValues, ErrorBuf, 2048);
  if ok = True then Result := ''
  else Result := ErrorBuf;
end;
//------------------

procedure NewExit; far;
begin
  ExitProc := SaveExit;
  FreeLibrary(DLLHandle)
end {NewExit};
//------------------

procedure LoadDLL;
begin
  if DLLLoaded then Exit;
{$IFNDEF MSDOS}
  ErrorMode := SetErrorMode($8000{SEM_NoOpenFileErrorBox});
{$ENDIF}
  DLLHandle := LoadLibrary('REPCODER.DLL');
  if DLLHandle >= 32 then
  begin
    DLLLoaded := True;
    SaveExit := ExitProc;
    ExitProc := @NewExit;
    
// REPCoder
@repc_init := GetProcAddress(DLLHandle,'repc_init'); Assert(@repc_init <> nil);
@repc_exit := GetProcAddress(DLLHandle,'repc_exit'); Assert(@repc_exit <> nil);
@repc_open_report := GetProcAddress(DLLHandle,'repc_open_report'); Assert(@repc_open_report <> nil);
@repc_open_report_a := GetProcAddress(DLLHandle,'repc_open_report_a'); Assert(@repc_open_report_a <> nil);
@repc_open_report2 := GetProcAddress(DLLHandle,'repc_open_report2'); Assert(@repc_open_report2 <> nil);
@repc_open_report2_a := GetProcAddress(DLLHandle,'repc_open_report2_a'); Assert(@repc_open_report2_a <> nil);
@repc_call_report := GetProcAddress(DLLHandle,'repc_call_report'); Assert(@repc_call_report <> nil);
@repc_call_report_a := GetProcAddress(DLLHandle,'repc_call_report_a'); Assert(@repc_call_report_a <> nil);
@repc_call_report_param := GetProcAddress(DLLHandle,'repc_call_report_param'); Assert(@repc_call_report_param <> nil);
@repc_call_report_param_a := GetProcAddress(DLLHandle,'repc_call_report_param_a'); Assert(@repc_call_report_param_a <> nil);
@repc_call_report_param2 := GetProcAddress(DLLHandle,'repc_call_report_param2'); Assert(@repc_call_report_param2 <> nil);
@repc_call_report_param2_a := GetProcAddress(DLLHandle,'repc_call_report_param2_a'); Assert(@repc_call_report_param2_a <> nil);    
@repc_explorer := GetProcAddress(DLLHandle,'repc_explorer'); Assert(@repc_explorer <> nil);
@repc_explorer_a := GetProcAddress(DLLHandle,'repc_explorer_a'); Assert(@repc_explorer_a <> nil);
@repc_explorer_param := GetProcAddress(DLLHandle,'repc_explorer_param'); Assert(@repc_explorer_param <> nil);
@repc_explorer_param_a := GetProcAddress(DLLHandle,'repc_explorer_param_a'); Assert(@repc_explorer_param_a <> nil);
@repc_get_report_desc_len := GetProcAddress(DLLHandle,'repc_get_report_desc_len'); Assert(@repc_get_report_desc_len <> nil);
@repc_get_report_desc := GetProcAddress(DLLHandle,'repc_get_report_desc'); Assert(@repc_get_report_desc <> nil);
@repc_get_report_desc_a := GetProcAddress(DLLHandle,'repc_get_report_desc_a'); Assert(@repc_get_report_desc_a <> nil);
@repc_alloc_report_desc := GetProcAddress(DLLHandle,'repc_alloc_report_desc'); Assert(@repc_alloc_report_desc <> nil);
@repc_alloc_report_desc_a := GetProcAddress(DLLHandle,'repc_alloc_report_desc_a'); Assert(@repc_alloc_report_desc_a <> nil);
@repc_free_memory := GetProcAddress(DLLHandle,'repc_free_memory'); Assert(@repc_free_memory <> nil);
@repc_get_open_count := GetProcAddress(DLLHandle,'repc_get_open_count'); Assert(@repc_get_open_count <> nil);
@repc_can_exit := GetProcAddress(DLLHandle,'repc_can_exit'); Assert(@repc_can_exit <> nil);
@repc_set_user := GetProcAddress(DLLHandle,'repc_set_user'); Assert(@repc_set_user <> nil);
@repc_set_user_a := GetProcAddress(DLLHandle,'repc_set_user_a'); Assert(@repc_set_user_a <> nil);
@repc_set_pass := GetProcAddress(DLLHandle,'repc_set_pass'); Assert(@repc_set_pass <> nil);
@repc_set_pass_a := GetProcAddress(DLLHandle,'repc_set_pass_a'); Assert(@repc_set_pass_a <> nil);
@repc_set_role := GetProcAddress(DLLHandle,'repc_set_role'); Assert(@repc_set_role <> nil);
@repc_set_role_a := GetProcAddress(DLLHandle,'repc_set_role_a'); Assert(@repc_set_role_a <> nil);
@repc_set_charset := GetProcAddress(DLLHandle,'repc_set_charset'); Assert(@repc_set_charset <> nil);
@repc_set_charset_a := GetProcAddress(DLLHandle,'repc_set_charset_a'); Assert(@repc_set_charset_a <> nil);
@repc_set_logo := GetProcAddress(DLLHandle,'repc_set_logo'); Assert(@repc_set_logo <> nil);
@repc_set_logo_a := GetProcAddress(DLLHandle,'repc_set_logo_a'); Assert(@repc_set_logo_a <> nil);
@repc_get_demo := GetProcAddress(DLLHandle,'repc_get_demo'); Assert(@repc_get_demo <> nil);
@repc_set_demo := GetProcAddress(DLLHandle,'repc_set_demo'); Assert(@repc_set_demo <> nil);
@repc_set_bde_netdir := GetProcAddress(DLLHandle,'repc_set_bde_netdir'); Assert(@repc_set_bde_netdir <> nil);
@repc_set_bde_netdir_a := GetProcAddress(DLLHandle,'repc_set_bde_netdir_a'); Assert(@repc_set_bde_netdir_a <> nil);
@repc_set_fbclient_thread_safe := GetProcAddress(DLLHandle,'repc_set_fbclient_thread_safe'); Assert(@repc_set_fbclient_thread_safe <> nil);
@repc_set_ibclient_thread_safe := GetProcAddress(DLLHandle,'repc_set_ibclient_thread_safe'); Assert(@repc_set_ibclient_thread_safe <> nil);
@repc_set_dialog_fonts := GetProcAddress(DLLHandle,'repc_set_dialog_fonts'); Assert(@repc_set_dialog_fonts <> nil);
@repc_set_user_interface_lang := GetProcAddress(DLLHandle,'repc_set_user_interface_lang'); Assert(@repc_set_user_interface_lang <> nil);
@repc_create_result := GetProcAddress(DLLHandle,'repc_create_result'); Assert(@repc_create_result <> nil);
@repc_create_result_a := GetProcAddress(DLLHandle,'repc_create_result_a'); Assert(@repc_create_result_a <> nil);
@repc_create_result_param := GetProcAddress(DLLHandle,'repc_create_result_param'); Assert(@repc_create_result <> nil);
@repc_create_result_param_a := GetProcAddress(DLLHandle,'repc_create_result_param_a'); Assert(@repc_create_result_a <> nil);
@repc_admin_setup := GetProcAddress(DLLHandle,'repc_admin_setup'); Assert(@repc_admin_setup <> nil);  
@repc_admin_setup_a := GetProcAddress(DLLHandle,'repc_admin_setup_a'); Assert(@repc_admin_setup_a <> nil);

// RCALC
@rcalc_alloc_handle := GetProcAddress(DLLHandle,'rcalc_alloc_handle'); Assert(@rcalc_alloc_handle <> nil);
@rcalc_copy_handle := GetProcAddress(DLLHandle,'rcalc_copy_handle'); Assert(@rcalc_copy_handle <> nil);
@rcalc_free_handle := GetProcAddress(DLLHandle,'rcalc_free_handle'); Assert(@rcalc_free_handle <> nil);
@rcalc_free_all_handles := GetProcAddress(DLLHandle,'rcalc_free_all_handles'); Assert(@rcalc_free_all_handles <> nil);
@rcalc_get_state := GetProcAddress(DLLHandle,'rcalc_get_state'); Assert(@rcalc_get_state <> nil);
@rcalc_is_valid := GetProcAddress(DLLHandle,'rcalc_is_valid'); Assert(@rcalc_is_valid <> nil);
@rcalc_is_compiled := GetProcAddress(DLLHandle,'rcalc_is_compiled'); Assert(@rcalc_is_compiled <> nil);
@rcalc_is_executed := GetProcAddress(DLLHandle,'rcalc_is_executed'); Assert(@rcalc_is_executed <> nil);
@rcalc_set_status_window := GetProcAddress(DLLHandle,'rcalc_set_status_window'); Assert(@rcalc_set_status_window <> nil);
@rcalc_compile := GetProcAddress(DLLHandle,'rcalc_compile'); Assert(@rcalc_compile <> nil);
@rcalc_compile_a := GetProcAddress(DLLHandle,'rcalc_compile_a'); Assert(@rcalc_compile_a <> nil);
@rcalc_compile_file := GetProcAddress(DLLHandle,'rcalc_compile_file'); Assert(@rcalc_compile_file <> nil);
@rcalc_compile_file_a := GetProcAddress(DLLHandle,'rcalc_compile_file_a'); Assert(@rcalc_compile_file_a <> nil);
@rcalc_show_error := GetProcAddress(DLLHandle,'rcalc_show_error'); Assert(@rcalc_show_error <> nil);
@rcalc_get_error_text_len := GetProcAddress(DLLHandle,'rcalc_get_error_text_len'); Assert(@rcalc_get_error_text_len <> nil);
@rcalc_copy_error_text := GetProcAddress(DLLHandle,'rcalc_copy_error_text'); Assert(@rcalc_copy_error_text <> nil);
@rcalc_copy_error_text_a := GetProcAddress(DLLHandle,'rcalc_copy_error_text_a'); Assert(@rcalc_copy_error_text_a <> nil);
@rcalc_alloc_error_text := GetProcAddress(DLLHandle,'rcalc_alloc_error_text'); Assert(@rcalc_alloc_error_text <> nil);
@rcalc_alloc_error_text_a := GetProcAddress(DLLHandle,'rcalc_alloc_error_text_a'); Assert(@rcalc_alloc_error_text_a <> nil);
@rcalc_get_compiled_text_len := GetProcAddress(DLLHandle,'rcalc_get_compiled_text_len'); Assert(@rcalc_get_compiled_text_len <> nil);
@rcalc_copy_compiled_text := GetProcAddress(DLLHandle,'rcalc_copy_compiled_text'); Assert(@rcalc_copy_compiled_text <> nil);
@rcalc_copy_compiled_text_a := GetProcAddress(DLLHandle,'rcalc_copy_compiled_text_a'); Assert(@rcalc_copy_compiled_text_a <> nil);
@rcalc_get_compiled_text := GetProcAddress(DLLHandle,'rcalc_get_compiled_text'); Assert(@rcalc_get_compiled_text <> nil);
@rcalc_get_compiled_text_a := GetProcAddress(DLLHandle,'rcalc_get_compiled_text_a'); Assert(@rcalc_get_compiled_text_a <> nil);
@rcalc_execute := GetProcAddress(DLLHandle,'rcalc_execute'); Assert(@rcalc_execute <> nil);
@rcalc_execute_a := GetProcAddress(DLLHandle,'rcalc_execute_a'); Assert(@rcalc_execute_a <> nil);
@rcalc_execute2 := GetProcAddress(DLLHandle,'rcalc_execute2'); Assert(@rcalc_execute2 <> nil);
@rcalc_execute2_a := GetProcAddress(DLLHandle,'rcalc_execute2_a'); Assert(@rcalc_execute2_a <> nil);
@rcalc_get_input_count := GetProcAddress(DLLHandle,'rcalc_get_input_count'); Assert(@rcalc_get_input_count <> nil);
@rcalc_get_input_name_len := GetProcAddress(DLLHandle,'rcalc_get_input_name_len'); Assert(@rcalc_get_input_name_len <> nil);
@rcalc_copy_input_name := GetProcAddress(DLLHandle,'rcalc_copy_input_name'); Assert(@rcalc_copy_input_name <> nil);
@rcalc_copy_input_name_a := GetProcAddress(DLLHandle,'rcalc_copy_input_name_a'); Assert(@rcalc_copy_input_name_a <> nil);
@rcalc_get_input_name := GetProcAddress(DLLHandle,'rcalc_get_input_name'); Assert(@rcalc_get_input_name <> nil);
@rcalc_get_input_name_a := GetProcAddress(DLLHandle,'rcalc_get_input_name_a'); Assert(@rcalc_get_input_name_a <> nil);
@rcalc_get_input_number := GetProcAddress(DLLHandle,'rcalc_get_input_number'); Assert(@rcalc_get_input_number <> nil);
@rcalc_get_input_number_a := GetProcAddress(DLLHandle,'rcalc_get_input_number_a'); Assert(@rcalc_get_input_number_a <> nil);
@rcalc_get_input_type := GetProcAddress(DLLHandle,'rcalc_get_input_type'); Assert(@rcalc_get_input_type <> nil);
@rcalc_get_input_type_numscale := GetProcAddress(DLLHandle,'rcalc_get_input_type_numscale'); Assert(@rcalc_get_input_type_numscale <> nil);
@rcalc_get_input_type_name_len := GetProcAddress(DLLHandle,'rcalc_get_input_type_name_len'); Assert(@rcalc_get_input_type_name_len <> nil);
@rcalc_copy_input_type_name := GetProcAddress(DLLHandle,'rcalc_copy_input_type_name'); Assert(@rcalc_copy_input_type_name <> nil);
@rcalc_copy_input_type_name_a := GetProcAddress(DLLHandle,'rcalc_copy_input_type_name_a'); Assert(@rcalc_copy_input_type_name_a <> nil);
@rcalc_get_input_type_name := GetProcAddress(DLLHandle,'rcalc_get_input_type_name'); Assert(@rcalc_get_input_type_name <> nil);
@rcalc_get_input_type_name_a := GetProcAddress(DLLHandle,'rcalc_get_input_type_name_a'); Assert(@rcalc_get_input_type_name_a <> nil);
@rcalc_get_output_count := GetProcAddress(DLLHandle,'rcalc_get_output_count'); Assert(@rcalc_get_output_count <> nil);
@rcalc_get_output_name_len := GetProcAddress(DLLHandle,'rcalc_get_output_name_len'); Assert(@rcalc_get_output_name_len <> nil);
@rcalc_copy_output_name := GetProcAddress(DLLHandle,'rcalc_copy_output_name'); Assert(@rcalc_copy_output_name <> nil);
@rcalc_copy_output_name_a := GetProcAddress(DLLHandle,'rcalc_copy_output_name_a'); Assert(@rcalc_copy_output_name_a <> nil);
@rcalc_get_output_name := GetProcAddress(DLLHandle,'rcalc_get_output_name'); Assert(@rcalc_get_output_name <> nil);
@rcalc_get_output_name_a := GetProcAddress(DLLHandle,'rcalc_get_output_name_a'); Assert(@rcalc_get_output_name_a <> nil);
@rcalc_get_output_number := GetProcAddress(DLLHandle,'rcalc_get_output_number'); Assert(@rcalc_get_output_number <> nil);
@rcalc_get_output_number_a := GetProcAddress(DLLHandle,'rcalc_get_output_number_a'); Assert(@rcalc_get_output_number_a <> nil);
@rcalc_get_output_type := GetProcAddress(DLLHandle,'rcalc_get_output_type'); Assert(@rcalc_get_output_type <> nil);
@rcalc_get_output_type_textlen := GetProcAddress(DLLHandle,'rcalc_get_output_type_textlen'); Assert(@rcalc_get_output_type_textlen <> nil);
@rcalc_get_output_type_numscale := GetProcAddress(DLLHandle,'rcalc_get_output_type_numscale'); Assert(@rcalc_get_output_type_numscale <> nil);
@rcalc_get_output_type_name_len := GetProcAddress(DLLHandle,'rcalc_get_output_type_name_len'); Assert(@rcalc_get_output_type_name_len <> nil);
@rcalc_copy_output_type_name := GetProcAddress(DLLHandle,'rcalc_copy_output_type_name'); Assert(@rcalc_copy_output_type_name <> nil);
@rcalc_copy_output_type_name_a := GetProcAddress(DLLHandle,'rcalc_copy_output_type_name_a'); Assert(@rcalc_copy_output_type_name_a <> nil);
@rcalc_get_output_type_name := GetProcAddress(DLLHandle,'rcalc_get_output_type_name'); Assert(@rcalc_get_output_type_name <> nil);
@rcalc_get_output_type_name_a := GetProcAddress(DLLHandle,'rcalc_get_output_type_name_a'); Assert(@rcalc_get_output_type_name_a <> nil);
@rcalc_isnull_input := GetProcAddress(DLLHandle,'rcalc_isnull_input'); Assert(@rcalc_isnull_input <> nil);
@rcalc_get_input_string := GetProcAddress(DLLHandle,'rcalc_get_input_string'); Assert(@rcalc_get_input_string <> nil);
@rcalc_get_input_string_a := GetProcAddress(DLLHandle,'rcalc_get_input_string_a'); Assert(@rcalc_get_input_string_a <> nil);
@rcalc_get_input_string_len := GetProcAddress(DLLHandle,'rcalc_get_input_string_len'); Assert(@rcalc_get_input_string_len <> nil);
@rcalc_copy_input_string := GetProcAddress(DLLHandle,'rcalc_copy_input_string'); Assert(@rcalc_copy_input_string <> nil);
@rcalc_copy_input_string_a := GetProcAddress(DLLHandle,'rcalc_copy_input_string_a'); Assert(@rcalc_copy_input_string_a <> nil);
@rcalc_get_input_double := GetProcAddress(DLLHandle,'rcalc_get_input_double'); Assert(@rcalc_get_input_double <> nil);
@rcalc_get_input_int := GetProcAddress(DLLHandle,'rcalc_get_input_int'); Assert(@rcalc_get_input_int <> nil);
@rcalc_get_input_numeric := GetProcAddress(DLLHandle,'rcalc_get_input_numeric'); Assert(@rcalc_get_input_numeric <> nil);
@rcalc_get_input_time := GetProcAddress(DLLHandle,'rcalc_get_input_time'); Assert(@rcalc_get_input_time <> nil);
@rcalc_isnull_output := GetProcAddress(DLLHandle,'rcalc_isnull_output'); Assert(@rcalc_isnull_output <> nil);
@rcalc_get_output_string := GetProcAddress(DLLHandle,'rcalc_get_output_string'); Assert(@rcalc_get_output_string <> nil);
@rcalc_get_output_string_a := GetProcAddress(DLLHandle,'rcalc_get_output_string_a'); Assert(@rcalc_get_output_string_a <> nil);
@rcalc_get_output_string_len := GetProcAddress(DLLHandle,'rcalc_get_output_string_len'); Assert(@rcalc_get_output_string_len <> nil);
@rcalc_copy_output_string := GetProcAddress(DLLHandle,'rcalc_copy_output_string'); Assert(@rcalc_copy_output_string <> nil);
@rcalc_copy_output_string_a := GetProcAddress(DLLHandle,'rcalc_copy_output_string_a'); Assert(@rcalc_copy_output_string_a <> nil);
@rcalc_get_output_double := GetProcAddress(DLLHandle,'rcalc_get_output_double'); Assert(@rcalc_get_output_double <> nil);
@rcalc_get_output_int := GetProcAddress(DLLHandle,'rcalc_get_output_int'); Assert(@rcalc_get_output_int <> nil);
@rcalc_get_output_numeric := GetProcAddress(DLLHandle,'rcalc_get_output_numeric'); Assert(@rcalc_get_output_numeric <> nil);
@rcalc_get_output_time := GetProcAddress(DLLHandle,'rcalc_get_output_time'); Assert(@rcalc_get_output_time <> nil);
@rcalc_get_year := GetProcAddress(DLLHandle,'rcalc_get_year'); Assert(@rcalc_get_year <> nil);
@rcalc_get_month := GetProcAddress(DLLHandle,'rcalc_get_month'); Assert(@rcalc_get_month <> nil);
@rcalc_get_day := GetProcAddress(DLLHandle,'rcalc_get_day'); Assert(@rcalc_get_day <> nil);
@rcalc_get_hour := GetProcAddress(DLLHandle,'rcalc_get_hour'); Assert(@rcalc_get_hour <> nil);
@rcalc_get_minute := GetProcAddress(DLLHandle,'rcalc_get_minute'); Assert(@rcalc_get_minute <> nil);
@rcalc_get_second := GetProcAddress(DLLHandle,'rcalc_get_second'); Assert(@rcalc_get_second <> nil);
@rcalc_get_millisec := GetProcAddress(DLLHandle,'rcalc_get_millisec'); Assert(@rcalc_get_millisec <> nil);
  
  end
  else
  begin
    DLLLoaded := False;
    { Error: REPCODER.DLL could not be loaded !!! }
  end;
{$IFNDEF MSDOS}
  SetErrorMode(ErrorMode)
{$ENDIF}
end {LoadDLL};
//------------------

// RCALC class

constructor RCALC.Create;
begin
  Handle := rcalc_alloc_handle();
end;
//------------------

constructor RCALC.Create(rc: RCALC);
begin
  Handle := rcalc_copy_handle(rc.Handle);
end;
//------------------

destructor RCALC.Destroy;
begin
  if Handle > 0 then rcalc_free_handle(Handle);
  inherited;
end;
//------------------

function RCALC.CopyFrom(rc: RCALC): Boolean;
var ok: Boolean;
begin
  if Handle = rc.Handle then begin Result := False; exit; end;

  if Handle > 0 then
  begin
    ok := rcalc_free_handle(Handle);
    if ok = True then
    begin
      Handle := rcalc_copy_handle(rc.Handle);
      if Handle > 0 then Result := True
      else Result := False;
    end
    else Result := False;
  end
  else Result := False;
end;
//------------------

function RCALC.GetHandle: Integer;
begin
  Result := Handle;
end;
//------------------

function RCALC.GetState: Integer;
begin
  Result := rcalc_get_state(Handle);
end;
//------------------

function RCALC.IsValid: Boolean;
begin
  Result := rcalc_is_valid(Handle);
end;
//------------------

function RCALC.IsCompiled: Boolean;
begin
  Result := rcalc_is_compiled(Handle);
end;
//------------------

function RCALC.IsExecuted: Boolean;
begin
  Result := rcalc_is_executed(Handle);
end;
//------------------

procedure RCALC.SetStatusWindow(hStatWnd: HWND);
begin
  rcalc_set_status_window(Handle, hStatWnd);
end;
//------------------

function RCALC.Compile(Source: WideString): Boolean;
begin
  Result := rcalc_compile(Handle, Source);
end;
//------------------

function RCALC.Compile(Source: AnsiString): Boolean;
begin
  Result := rcalc_compile_a(Handle, Source);
end;
//------------------

function RCALC.CompileFile(Source: WideString; Format: Integer): Boolean;
begin
  Result := rcalc_compile_file(Handle, Source, Format);
end;
//------------------

function RCALC.CompileFile(Source: AnsiString; Format: Integer): Boolean;
begin
  Result := rcalc_compile_file_a(Handle, Source, Format);
end;
//------------------

function RCALC.Execute(nInput: Integer; pInputValues: PWideString): Boolean;
begin
  Result := rcalc_execute(Handle, nInput, pInputValues);
end;
//------------------

function RCALC.ExecuteA(nInput: Integer; pInputValues: PAnsiString): Boolean;
begin
  Result := rcalc_execute_a(Handle, nInput, pInputValues);
end;
//------------------

function RCALC.Execute(InputValues: WideString; Separator: WideString): Boolean;
begin
  Result := rcalc_execute2(Handle, InputValues, Separator);
end;
//------------------

function RCALC.ExecuteA(InputValues: AnsiString; Separator: AnsiString): Boolean;
begin
  Result := rcalc_execute2_a(Handle, InputValues, Separator);
end;
//------------------

function RCALC.Execute(InputValues: WideString): Boolean;
begin
  Result := rcalc_execute2(Handle, InputValues, '###');
end;
//------------------

function RCALC.ExecuteA(InputValues: AnsiString): Boolean;
begin
  Result := rcalc_execute2_a(Handle, InputValues, '###');
end;
//------------------

function RCALC.Execute: Boolean;
begin
  Result := rcalc_execute2(Handle, '', '');
end;
//------------------

function RCALC.CompiledText(bCRLF: Boolean): WideString;
begin
  Result := rcalc_get_compiled_text(Handle, bCRLF);
end;
//------------------

function RCALC.CompiledTextA(bCRLF: Boolean): AnsiString;
begin
  Result := rcalc_get_compiled_text_a(Handle, bCRLF);
end;
//------------------

function RCALC.InputCount: Integer;
begin
  Result := rcalc_get_input_count(Handle);
end;
//------------------

function RCALC.InputType(number: Integer): Integer;
begin
  Result := rcalc_get_input_type(Handle, number);
end;
//------------------

function RCALC.InputTypeNumericScale(number: Integer): Integer;
begin
  Result := rcalc_get_input_type_numscale(Handle, number);
end;
//------------------

function RCALC.InputTypeName(number: Integer): WideString;
begin
  Result := rcalc_get_input_type_name(Handle, number);
end;
//------------------

function RCALC.InputTypeNameA(number: Integer): AnsiString;
begin
  Result := rcalc_get_input_type_name_a(Handle, number);
end;
//------------------

function RCALC.InputName(number: Integer): WideString;
begin
  Result := rcalc_get_input_name(Handle, number);
end;
//------------------

function RCALC.InputNameA(number: Integer): AnsiString;
begin
  Result := rcalc_get_input_name_a(Handle, number);
end;
//------------------

function RCALC.InputIsNull(number: Integer): Boolean;
begin
  Result := rcalc_isnull_input(Handle, number);
end;
//------------------

function RCALC.InputString(number: Integer): WideString;
begin
  Result := rcalc_get_input_string(Handle, number);
end;
//------------------

function RCALC.InputStringA(number: Integer): AnsiString;
begin
  Result := rcalc_get_input_string_a(Handle, number);
end;
//------------------

function RCALC.InputDouble(number: Integer): Double;
begin
  Result := rcalc_get_input_double(Handle, number);
end;
//------------------

function RCALC.InputInt(number: Integer): Integer;
begin
  Result := rcalc_get_input_int(Handle, number);
end;
//------------------

function RCALC.InputNumeric(number: Integer): Int64;
begin
  Result := rcalc_get_input_numeric(Handle, number);
end;
//------------------

function RCALC.InputTime(number: Integer): Int64;
begin
  Result := rcalc_get_input_time(Handle, number);
end;
//------------------

function RCALC.OutputCount: Integer;
begin
  Result := rcalc_get_output_count(Handle);
end;
//------------------

function RCALC.OutType(number: Integer): Integer;
begin
  Result := rcalc_get_output_type(Handle, number);
end;
//------------------

function RCALC.OutTypeTextLen(number: Integer): Integer;
begin
  Result := rcalc_get_output_type_textlen(Handle, number);
end;
//------------------

function RCALC.OutTypeNumericScale(number: Integer): Integer;
begin
  Result := rcalc_get_output_type_numscale(Handle, number);
end;
//------------------

function RCALC.OutTypeName(number: Integer): WideString;
begin
  Result := rcalc_get_output_type_name(Handle, number);
end;
//------------------

function RCALC.OutTypeNameA(number: Integer): AnsiString;
begin
  Result := rcalc_get_output_type_name_a(Handle, number);
end;
//------------------

function RCALC.OutName(number: Integer): WideString;
begin
  Result := rcalc_get_output_name(Handle, number);
end;
//------------------

function RCALC.OutNameA(number: Integer): AnsiString;
begin
  Result := rcalc_get_output_name_a(Handle, number);
end;
//------------------

function RCALC.OutIsNull(number: Integer): Boolean;
begin
  Result := rcalc_isnull_output(Handle, number);
end;
//------------------

function RCALC.OutString(number: Integer): WideString;
begin
  Result := rcalc_get_output_string(Handle, number);
end;
//------------------

function RCALC.OutStringA(number: Integer): AnsiString;
begin
  Result := rcalc_get_output_string_a(Handle, number);
end;
//------------------

function RCALC.OutDouble(number: Integer): Double;
begin
  Result := rcalc_get_output_double(Handle, number);
end;
//------------------

function RCALC.OutInt(number: Integer): Integer;
begin
  Result := rcalc_get_output_int(Handle, number);
end;
//------------------

function RCALC.OutNumeric(number: Integer): Int64;
begin
  Result := rcalc_get_output_numeric(Handle, number);
end;
//------------------

function RCALC.OutTime(number: Integer): Int64;
begin
  Result := rcalc_get_output_time(Handle, number);
end;
//------------------

// RCALC global functions:

function RCALC_Year(value: Int64): Integer;
begin
  Result := rcalc_get_year(value);
end;
//------------------

function RCALC_Month(value: Int64): Integer;
begin
  Result := rcalc_get_month(value);
end;
//------------------

function RCALC_Day(value: Int64): Integer;
begin
  Result := rcalc_get_day(value);
end;
//------------------

function RCALC_Hour(value: Int64): Integer;
begin
  Result := rcalc_get_hour(value);
end;
//------------------

function RCALC_Minute(value: Int64): Integer;
begin
  Result := rcalc_get_minute(value);
end;
//------------------

function RCALC_Second(value: Int64): Integer;
begin
  Result := rcalc_get_second(value);
end;
//------------------

function RCALC_Millisec(value: Int64): Integer;
begin
  Result := rcalc_get_millisec(value);
end;
//------------------

function RCALC_LastError: Boolean;
begin
  if rcalc_get_error_text_len > 0 then Result := True
  else Result := False;
end;
//------------------

procedure RCALC_ShowError(hParent: HWND);
begin
  rcalc_show_error(hParent);
end;
//------------------

function RCALC_ErrorString: WideString;
var ptr: PWideChar;
begin
  ptr := rcalc_alloc_error_text;
  Result := ptr;
  repc_free_memory(ptr);
end;
//------------------

function RCALC_ErrorStringA: AnsiString;
var ptr: PChar;
begin
  ptr := rcalc_alloc_error_text_a;
  Result := ptr;
  repc_free_memory(ptr);
end;
//------------------

begin
  LoadDLL;
end.
